/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-13.aml, Thu Aug 10 00:36:10 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000FAB (4011)
 *     Revision         0x01
 *     Checksum         0x70
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "NvOptTbl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20141107 (538185991)
 */
DefinitionBlock ("", "SSDT", 1, "LENOVO", "NvOptTbl", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- refs.txt
     */

    External (_GPE.MMTB, MethodObj)    // Imported: 0 Arguments
    External (_GPE.VHOV, MethodObj)    // Imported: 3 Arguments
    External (_PR_.CPU0.LPSS, IntObj)    // Warning: Unknown object
    External (_PR_.CPU0.TPSS, IntObj)    // Warning: Unknown object
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPC_.EC__.AC__._PSR, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.LPC_.EC__.BVPC, IntObj)
    External (_SB_.PCI0.LPC_.EC__.HKEY.ANDN, IntObj)
    External (_SB_.PCI0.LPC_.EC__.HKEY.ANGN, IntObj)
    External (_SB_.PCI0.LPC_.EC__.HKEY.GPTL, IntObj)
    External (_SB_.PCI0.LPC_.EC__.TMP0, FieldUnitObj)
    External (_SB_.PCI0.LPC_.EC__.VPON, FieldUnitObj)
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.PEG0, DeviceObj)
    External (_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.PGOF, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.PGON, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // Imported: 4 Arguments
    External (_SB_.PCI0.SBN0, FieldUnitObj)
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // Imported: 2 Arguments
    External (MDBG, MethodObj)    // Imported: 1 Arguments
    External (NVHA, FieldUnitObj)
    External (NVID, FieldUnitObj)
    External (OSYS, FieldUnitObj)
    External (PDC0, IntObj)
    External (PNTF, MethodObj)    // 1 Arguments
    External (VIGD, FieldUnitObj)
    External (XBAS, FieldUnitObj)

    Scope (\_SB.PCI0.PEG0)
    {
        Name (CMDS, Zero)
        Name (DBUF, Zero)
        OperationRegion (PG0R, SystemMemory, Add (\XBAS, 0x8000), 0x90)
        Field (PG0R, DWordAcc, NoLock, Preserve)
        {
            Offset (0x84), 
            PWRS,   8
        }

        OperationRegion (PG0X, SystemMemory, Add (\XBAS, 0x00100000), 0x0500)
        Field (PG0X, DWordAcc, Lock, Preserve)
        {
            Offset (0x04), 
            CMDR,   8, 
            Offset (0x40), 
            NIDR,   32, 
            Offset (0x488), 
                ,   25, 
            MLTR,   1
        }

        Method (MSOF, 0, NotSerialized)
        {
        }

        Method (MSON, 0, NotSerialized)
        {
        }

        Method (DGOF, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.LPC.EC.VPON)
        }

        Method (DGON, 0, NotSerialized)
        {
            Store (One, \_SB.PCI0.LPC.EC.VPON)
        }
    }

    Scope (\)
    {
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (NVHM, SystemMemory, NVHA, 0x00030400)
        Field (NVHM, AnyAcc, NoLock, Preserve)
        {
            Offset (0x100), 
            NVHO,   32, 
            RVBS,   32, 
            Offset (0x400), 
            RBF1,   786432, 
            RBF2,   786432
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (_ROM, 2, Serialized)  // _ROM: Read-Only Memory
        {
            If (LGreaterEqual (Arg0, 0x00018000))
            {
                Return (GETB (Subtract (Arg0, 0x00018000), Arg1, RBF2))
            }

            If (LGreater (Add (Arg0, Arg1), 0x00018000))
            {
                Subtract (0x00018000, Arg0, Local0)
                Subtract (Arg1, Local0, Local1)
                Store (GETB (Arg0, Local0, RBF1), Local3)
                Store (GETB (Zero, Local1, RBF2), Local4)
                Concatenate (Local3, Local4, Local5)
                Return (Local5)
            }

            Return (GETB (Arg0, Arg1, RBF1))
        }

        Method (GETB, 3, Serialized)
        {
            Multiply (Arg0, 0x08, Local0)
            Multiply (Arg1, 0x08, Local1)
            CreateField (Arg2, Local0, Local1, TBF3)
            Return (TBF3)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (GOBT, 1, NotSerialized)
        {
            Name (OPVK, Buffer (0xE6)
            {
                /* 0000 */  0xE4, 0xB8, 0x4F, 0x51, 0x50, 0x72, 0x8A, 0xC2,
                /* 0008 */  0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00,
                /* 0010 */  0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35,
                /* 0018 */  0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75,
                /* 0020 */  0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44,
                /* 0028 */  0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69,
                /* 0030 */  0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74,
                /* 0038 */  0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61,
                /* 0040 */  0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65,
                /* 0048 */  0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66,
                /* 0050 */  0x6F, 0x72, 0x20, 0x36, 0x38, 0x38, 0x33, 0x32,
                /* 0058 */  0x35, 0x6E, 0x6F, 0x7A, 0x6F, 0x6D, 0x69, 0x32,
                /* 0060 */  0x31, 0x44, 0x35, 0x20, 0x20, 0x20, 0x20, 0x20,
                /* 0068 */  0x2D, 0x20, 0x40, 0x4A, 0x20, 0x24, 0x55, 0x27,
                /* 0070 */  0x5C, 0x22, 0x54, 0x20, 0x29, 0x5F, 0x47, 0x42,
                /* 0078 */  0x20, 0x50, 0x2F, 0x41, 0x4F, 0x5C, 0x37, 0x22,
                /* 0080 */  0x3D, 0x46, 0x37, 0x39, 0x4B, 0x37, 0x2B, 0x5F,
                /* 0088 */  0x3F, 0x4B, 0x48, 0x5C, 0x5F, 0x46, 0x58, 0x48,
                /* 0090 */  0x5F, 0x44, 0x57, 0x32, 0x26, 0x4A, 0x46, 0x50,
                /* 0098 */  0x52, 0x25, 0x24, 0x2F, 0x46, 0x24, 0x20, 0x2D,
                /* 00A0 */  0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67,
                /* 00A8 */  0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20,
                /* 00B0 */  0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43,
                /* 00B8 */  0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69,
                /* 00C0 */  0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52,
                /* 00C8 */  0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65,
                /* 00D0 */  0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31,
                /* 00D8 */  0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36,
                /* 00E0 */  0x39, 0x38, 0x35, 0x28, 0x52, 0x29             
            })
            CreateWordField (Arg0, 0x02, USRG)
            If (LEqual (USRG, 0x564B))
            {
                Return (OPVK)
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (OMPR, 0x02)
        Name (OPTF, Zero)
        Name (GPRF, Zero)
        Name (HDAS, Zero)
        Method (NVOP, 4, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            Store ("------- NV OPTIMUS DSM --------", Debug)
            If (LNotEqual (Arg1, 0x0100))
            {
                Return (0x80000001)
            }

            While (One)
            {
                Store (ToInteger (Arg2), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Store (Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                         
                        }, Local0)
                    Divide (Zero, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x1A, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x10, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x1B, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x1A))
                {
                    CreateField (Arg3, 0x18, 0x02, OPCE)
                    CreateField (Arg3, Zero, One, FLCH)
                    CreateField (Arg3, One, One, DVSR)
                    CreateField (Arg3, 0x02, One, DVSC)
                    If (ToInteger (FLCH))
                    {
                        Store (OPCE, OMPR)
                    }

                    Store (Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                         
                        }, Local0)
                    CreateField (Local0, Zero, One, OPEN)
                    CreateField (Local0, 0x03, 0x02, CGCS)
                    CreateField (Local0, 0x06, One, SHPC)
                    CreateField (Local0, 0x08, One, SNSR)
                    CreateField (Local0, 0x18, 0x03, DGPC)
                    CreateField (Local0, 0x1B, 0x02, HDAC)
                    Store (One, OPEN)
                    Store (One, SHPC)
                    Store (0x02, HDAC)
                    If (ToInteger (DVSC))
                    {
                        If (ToInteger (DVSR))
                        {
                            Store (One, GPRF)
                        }
                        Else
                        {
                            Store (Zero, GPRF)
                        }
                    }

                    Store (GPRF, SNSR)
                    Store (One, DGPC)
                    If (\_SB.PCI0.PEG0.PEGP._STA ())
                    {
                        Store (0x03, CGCS)
                    }

                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x1B))
                {
                    Store (Arg3, Local0)
                    CreateField (Local0, Zero, One, OPFL)
                    CreateField (Local0, One, One, OPVL)
                    If (ToInteger (OPVL))
                    {
                        Store (Zero, OPTF)
                        Store (Zero, HDAS)
                        If (ToInteger (OPFL))
                        {
                            Store (One, OPTF)
                            Store (One, HDAS)
                        }
                    }

                    Store (OPTF, Local0)
                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x10))
                {
                    Return (\_SB.PCI0.PEG0.PEGP.GOBT (Arg3))
                }

                Break
            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (DGOS, Zero)
        OperationRegion (VGAR, SystemMemory, Add (XBAS, ShiftLeft (SBN0, 0x14)), 0x0100)
        Field (VGAR, DWordAcc, NoLock, Preserve)
        {
            VREG,   2048
        }

        Name (VGAB, Buffer (0x0100)
        {
             0x00                                           
        })
        OperationRegion (PCNV, PCI_Config, 0x0488, 0x04)
        Field (PCNV, AnyAcc, NoLock, Preserve)
        {
                ,   25, 
            MLTF,   1
        }

        Method (_STA, 0, NotSerialized)  // _STA: Status
        {
            Return (0x0F)
        }

        Method (_ON, 0, Serialized)  // _ON_: Power On
        {
            \_SB.PCI0.PGON (Zero)
            If (LNotEqual (GPRF, One))
            {
                Store (VGAB, VREG)
            }

            Return (Zero)
        }

        Method (_OFF, 0, Serialized)  // _OFF: Power Off
        {
            If (LNotEqual (GPRF, One))
            {
                Store (VREG, VGAB)
            }

            \_SB.PCI0.PGOF (Zero)
            Return (Zero)
        }

        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
            If (DGOS)
            {
                \_SB.PCI0.PEG0.PEGP._ON ()
                Store (Zero, DGOS)
                Store (Zero, MLTF)
            }
        }

        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
            If (LEqual (\_SB.PCI0.PEG0.PEGP.OMPR, 0x03))
            {
                \_SB.PCI0.PEG0.PEGP._OFF ()
                Store (One, DGOS)
                Store (0x02, \_SB.PCI0.PEG0.PEGP.OMPR)
            }

            Store (Zero, \_SB.PCI0.LPC.EC.HKEY.ANGN)
            Store (Zero, \_SB.PCI0.LPC.EC.HKEY.ANDN)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (CPPC, Zero)
        Name (RQTC, Zero)
        Name (PSAP, Zero)
        Method (NVPS, 4, Serialized)
        {
            Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            Store ("------- NV GPS DSM --------", Debug)
            While (One)
            {
                Store (ToInteger (Arg2), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Store (Buffer (0x08)
                        {
                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
                        }, Local0)
                    Store (Buffer (0x08)
                        {
                             0x00, 0x20, 0x21, 0x22, 0x23, 0x2A, 0x13, 0xFF 
                        }, Local3)
                    Store (Zero, Local4)
                    Store (DerefOf (Index (Local3, Local4)), Local5)
                    While (LNotEqual (Local5, 0xFF))
                    {
                        Divide (Local5, 0x08, Local2, Local1)
                        ShiftLeft (One, Local2, Local2)
                        Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                        Increment (Local4)
                        Store (DerefOf (Index (Local3, Local4)), Local5)
                    }

                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x13))
                {
                    Store (Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                         
                        }, Local0)
                    CreateField (Arg3, 0x02, One, PPST)
                    CreateBitField (Local0, 0x02, CPST)
                    If (LEqual (\_SB.PCI0.LPC.EC.HKEY.ANDN, Zero))
                    {
                        Store (One, \_SB.PCI0.LPC.EC.HKEY.ANGN)
                        Store (One, RQTC)
                        Notify (\_SB.PCI0.PEG0.PEGP, 0xC0)
                    }

                    If (LEqual (\_SB.PCI0.LPC.EC.HKEY.ANDN, Zero))
                    {
                        Store (One, \_SB.PCI0.LPC.EC.HKEY.ANDN)
                        If (LEqual (\_SB.PCI0.LPC.EC.AC._PSR (), One))
                        {
                            Notify (\_SB.PCI0.PEG0.PEGP, 0xD1)
                            Store (One, \_SB.PCI0.LPC.EC.BVPC)
                        }
                        Else
                        {
                            Notify (\_SB.PCI0.PEG0.PEGP, 0xD3)
                            Store (One, \_SB.PCI0.LPC.EC.BVPC)
                        }
                    }

                    If (LAnd (ToInteger (PPST), One))
                    {
                        If (LEqual (\_SB.PCI0.LPC.EC.BVPC, One))
                        {
                            Store (Zero, \_SB.PCI0.LPC.EC.BVPC)
                        }
                    }

                    Store (One, CPST)
                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x20))
                {
                    Store (Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                         
                        }, Local0)
                    CreateField (Local0, Zero, One, SPLU)
                    CreateField (Local0, 0x18, One, CUIT)
                    CreateField (Local0, 0x1E, One, PSER)
                    Store (One, CUIT)
                    Store (One, PSER)
                    If (RQTC)
                    {
                        Store (One, SPLU)
                        Store (Zero, RQTC)
                    }

                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x21))
                {
                    If (And (\PDC0, 0x0400))
                    {
                        Return (\_PR.CPU0.TPSS)
                    }
                    Else
                    {
                        Return (\_PR.CPU0.LPSS)
                    }
                }
                ElseIf (LEqual (_T_0, 0x22))
                {
                    CreateDWordField (Arg3, Zero, PCAP)
                    Store (PCAP, CPPC)
                    \PNTF (0x80)
                    Store (PCAP, PSAP)
                    Return (PCAP)
                }
                ElseIf (LEqual (_T_0, 0x23))
                {
                    Store ("GPS fun 23", Debug)
                    Return (PSAP)
                }
                ElseIf (LEqual (_T_0, 0x2A))
                {
                    Store (Buffer (0x24)
                        {
                            /* 0000 */  0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            /* 0018 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            /* 0020 */  0x00, 0x00, 0x00, 0x00                         
                        }, Local0)
                    Store (DerefOf (Index (Arg3, Zero)), Index (Local0, Zero))
                    CreateField (Arg3, Zero, 0x04, QTYP)
                    While (One)
                    {
                        Store (ToInteger (QTYP), _T_1)
                        If (LEqual (_T_1, Zero))
                        {
                            Store (\_SB.PCI0.LPC.EC.TMP0, Local1)
                            Store (And (Local1, 0xFF), Index (Local0, 0x0C))
                            Return (Local0)
                        }
                        ElseIf (LEqual (_T_1, One))
                        {
                            Store (0x08, Index (Local0, 0x0D))
                            Store (0x03, Index (Local0, One))
                            Return (Local0)
                        }
                        ElseIf (LEqual (_T_1, 0x02))
                        {
                            Store (0x03, Index (Local0, One))
                            Store (\_SB.PCI0.LPC.EC.HKEY.GPTL, Index (Local0, 0x08))
                            Return (Local0)
                        }

                        Break
                    }
                }

                Break
            }

            Return (Buffer (0x04)
            {
                 0x02, 0x00, 0x00, 0x80                         
            })
        }

        Method (NVST, 0, NotSerialized)
        {
            Store (One, RQTC)
            Notify (\_SB.PCI0.PEG0.PEGP, 0xC0)
        }
    }

    Scope (\)
    {
        Method (CMPB, 2, NotSerialized)
        {
            Store (SizeOf (Arg0), Local1)
            If (LNotEqual (Local1, SizeOf (Arg1)))
            {
                Return (Zero)
            }

            Store (Zero, Local0)
            While (LLess (Local0, Local1))
            {
                If (LNotEqual (DerefOf (Index (Arg0, Local0)), DerefOf (Index (Arg1, Local0))))
                {
                    Return (Zero)
                }

                Increment (Local0)
            }

            Return (One)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (MXM3, Buffer (0x5D)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x55, 0x00,
            /* 0008 */  0x60, 0xEC, 0x68, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0010 */  0x60, 0x6B, 0x62, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0018 */  0x20, 0x6B, 0x62, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0020 */  0x60, 0x69, 0x52, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0028 */  0x20, 0x69, 0x52, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0030 */  0x60, 0x6A, 0x5A, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0038 */  0x20, 0x6A, 0x5A, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0040 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
            /* 0048 */  0x12, 0x1A, 0x04, 0x00, 0x03, 0x03, 0xF4, 0x01,
            /* 0050 */  0x13, 0x02, 0xE8, 0x03, 0xF5, 0xFF, 0x0F, 0x05,
            /* 0058 */  0x00, 0x00, 0x00, 0x00, 0xA6                   
        })
        Name (MXSG, Buffer (0x55)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x4D, 0x00,
            /* 0008 */  0x60, 0x6B, 0x62, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0010 */  0x20, 0x6B, 0x62, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0018 */  0x60, 0x69, 0x52, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0020 */  0x20, 0x69, 0x52, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0028 */  0x60, 0x6A, 0x5A, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0030 */  0x20, 0x6A, 0x5A, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0038 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
            /* 0040 */  0x12, 0x1A, 0x04, 0x00, 0x03, 0x03, 0xF4, 0x01,
            /* 0048 */  0x13, 0x02, 0xE8, 0x03, 0xF5, 0xFF, 0xFF, 0x0F,
            /* 0050 */  0x05, 0x00, 0x00, 0x00, 0x99                   
        })
        Name (MXMA, Buffer (0x6D)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x65, 0x00,
            /* 0008 */  0x60, 0xEC, 0x68, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0010 */  0x60, 0x6B, 0x62, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0018 */  0x20, 0x6B, 0x62, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0020 */  0x60, 0x69, 0x52, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0028 */  0x20, 0x69, 0x52, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0030 */  0x60, 0x6A, 0x5A, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0038 */  0x20, 0x6A, 0x5A, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0040 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
            /* 0048 */  0x12, 0x1A, 0x04, 0x00, 0x03, 0x03, 0xF4, 0x01,
            /* 0050 */  0x13, 0x02, 0xE8, 0x03, 0x93, 0x00, 0xEE, 0x02,
            /* 0058 */  0xA3, 0x00, 0x26, 0x02, 0xB3, 0x00, 0xFA, 0x00,
            /* 0060 */  0xC3, 0x00, 0x64, 0x00, 0xF5, 0xFF, 0xFF, 0xAF,
            /* 0068 */  0x08, 0x00, 0x00, 0x00, 0xD2                   
        })
        Name (MXMB, Buffer (0x65)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x5D, 0x00,
            /* 0008 */  0x60, 0x6B, 0x62, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0010 */  0x20, 0x6B, 0x62, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0018 */  0x60, 0x69, 0x52, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0020 */  0x20, 0x69, 0x52, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0028 */  0x60, 0x6A, 0x5A, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0030 */  0x20, 0x6A, 0x5A, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0038 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
            /* 0040 */  0x12, 0x1A, 0x04, 0x00, 0x03, 0x03, 0xF4, 0x01,
            /* 0048 */  0x13, 0x02, 0xE8, 0x03, 0x93, 0x00, 0xEE, 0x02,
            /* 0050 */  0xA3, 0x00, 0x26, 0x02, 0xB3, 0x00, 0xFA, 0x00,
            /* 0058 */  0xC3, 0x00, 0x64, 0x00, 0xF5, 0xFF, 0xFF, 0xBF,
            /* 0060 */  0x08, 0x00, 0x00, 0x00, 0xB4                   
        })
        Name (MXMC, Buffer (0x6D)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x65, 0x00,
            /* 0008 */  0x60, 0xEC, 0x68, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0010 */  0x60, 0x6B, 0x62, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0018 */  0x20, 0x6B, 0x62, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0020 */  0x60, 0x69, 0x52, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0028 */  0x20, 0x69, 0x52, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0030 */  0x60, 0x6A, 0x5A, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0038 */  0x20, 0x6A, 0x5A, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0040 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
            /* 0048 */  0x12, 0x1A, 0x04, 0x00, 0x03, 0x03, 0xFA, 0x00,
            /* 0050 */  0x13, 0x02, 0xFA, 0x00, 0x93, 0x00, 0xFA, 0x00,
            /* 0058 */  0xA3, 0x00, 0xFA, 0x00, 0xB3, 0x00, 0xFA, 0x00,
            /* 0060 */  0xC3, 0x00, 0x64, 0x00, 0xF5, 0xFF, 0xFF, 0xCF,
            /* 0068 */  0x08, 0x00, 0x00, 0x00, 0xC2                   
        })
        Name (MXMD, Buffer (0x65)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x5D, 0x00,
            /* 0008 */  0x60, 0x6B, 0x62, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0010 */  0x20, 0x6B, 0x62, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0018 */  0x60, 0x69, 0x52, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0020 */  0x20, 0x69, 0x52, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0028 */  0x60, 0x6A, 0x5A, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
            /* 0030 */  0x20, 0x6A, 0x5A, 0xFD, 0xF9, 0x3E, 0x00, 0x00,
            /* 0038 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
            /* 0040 */  0x12, 0x1A, 0x04, 0x00, 0x03, 0x03, 0xFA, 0x00,
            /* 0048 */  0x13, 0x02, 0xFA, 0x00, 0x93, 0x00, 0xFA, 0x00,
            /* 0050 */  0xA3, 0x00, 0xFA, 0x00, 0xB3, 0x00, 0xFA, 0x00,
            /* 0058 */  0xC3, 0x00, 0x64, 0x00, 0xF5, 0xFF, 0xFF, 0xDF,
            /* 0060 */  0x08, 0x00, 0x00, 0x00, 0xA4                   
        })
        Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
        {
            If (LEqual (Arg0, ToUUID ("a486d8f8-0bda-471b-a72b-6042a6b5bee0")))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NVOP (Arg0, Arg1, Arg2, Arg3))
            }

            Store ("<<< _DSM - Perf >>>", Debug)
            Store (Arg0, Debug)
            Store (Arg1, Debug)
            Store (Arg2, Debug)
            Store (Arg3, Debug)
            If (CMPB (Arg0, ToUUID ("a3132d01-8cda-49ba-a52e-bc9d46df6b81")))
            {
                Return (NVPS (Arg0, Arg1, Arg2, Arg3))
            }

            If (LEqual (Arg0, ToUUID ("4004a400-917d-4cf2-b89c-79b62fd55665")))
            {
                Store (ToInteger (Arg2), Local0)
                If (LEqual (Local0, Zero))
                {
                    Return (Buffer (0x04)
                    {
                         0x01, 0x00, 0x01, 0x01                         
                    })
                }

                If (LEqual (Local0, 0x18))
                {
                    Return (Buffer (0x04)
                    {
                         0x30, 0x00, 0x00, 0x00                         
                    })
                }

                If (LEqual (Local0, 0x10))
                {
                    If (LEqual (Arg1, 0x0300))
                    {
                        If (LOr (LOr (LEqual (\NVID, 0x13FA10DE), LEqual (\NVID, 0x13F810DE)), LEqual (\NVID, 0x13F910DE)))
                        {
                            If (\VIGD)
                            {
                                Return (MXMB)
                            }
                            Else
                            {
                                Return (MXMA)
                            }
                        }
                        ElseIf (LEqual (\NVID, 0x13B210DE))
                        {
                            If (\VIGD)
                            {
                                Return (MXMD)
                            }
                            Else
                            {
                                Return (MXMC)
                            }
                        }
                    }
                }

                Return (0x80000002)
            }

            If (LEqual (Arg0, ToUUID ("d4a50b75-65c7-46f7-bfb7-41514cea0244")))
            {
                If (LEqual (Arg1, 0x0102))
                {
                    If (LEqual (Arg2, Zero))
                    {
                        Return (0x00100001)
                    }

                    If (LEqual (Arg2, 0x14))
                    {
                        Name (BLPK, Package (0x09)
                        {
                            0x8000A450, 
                            0x0100, 
                            Zero, 
                            Zero, 
                            One, 
                            One, 
                            0xFA, 
                            Zero, 
                            0x03E8
                        })
                        If (LGreaterEqual (OSYS, 0x07D9))
                        {
                            Store (0x0200, Index (BLPK, One))
                        }

                        Store (0xDC, Index (BLPK, 0x06))
                        Store (0x0A, Index (BLPK, 0x07))
                        Store (0x03E8, Index (BLPK, 0x08))
                        Return (BLPK)
                    }
                }

                Return (0x80000002)
            }

            Return (0x80000001)
        }
    }
}

